//#include <gl/glut.h>
#include <gl\glut.h>
#include <gl\glaux.h>
#include "GUIGL.h"

int BorderSize = 20;

_iPoint2D Point2D(float x,float y)
{
_iPoint2D tmp;
tmp.x = x;
tmp.y = y;
return tmp;
}


void Empty()
{
}

void CreateTexture(UINT textureArray[], LPSTR strFileName, int textureID)
{
	AUX_RGBImageRec *pBitmap = NULL;
	if(!strFileName)
		return;
	pBitmap = auxDIBImageLoad(strFileName);	
	if(pBitmap == NULL)						
		exit(0);
	glGenTextures(1, &textureArray[textureID]);
	glBindTexture(GL_TEXTURE_2D, textureArray[textureID]);
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, pBitmap->sizeX, pBitmap->sizeY, GL_RGB, GL_UNSIGNED_BYTE, pBitmap->data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	if (pBitmap)									
	{
	if (pBitmap->data)							
	{
	free(pBitmap->data);					
	}
	free(pBitmap);								
	}
}

void _HUD::SetFocusWindows(int Win)
{
if(Win==-1) return;
if(Windows[Win].Place == 1) return;

if(Windows[Win].Place==0)
{
for(int i=0;i<NDWindows;i++)
Windows[i].Place++;
}
else
{

for(int i=0;i<NDWindows;i++)
if(Windows[i].Place<Windows[Win].Place)Windows[i].Place++;

}

Windows[Win].Place = 1;
}

void _HUD::SetHUDSize(float x,float y)
{
WindowsX=x;
WindowsY=y;
}

void _HUD::MouseMove(float x,float y)
{
y -= WindowsY;
y*=-1;

MousePos.x = x;
MousePos.y = y;

if(WinMove!=-1)
{
Windows[WinMove].Position.x = x - MousePosFC.x;
Windows[WinMove].Position.y = y - MousePosFC.y;
SetFocusWindows(WinMove);
}

}

int _HUD::ClickWindows(int x,int y)
{
int LastWin=-1;
int LastPos=1000; 
for(int i=0;i<NDWindows;i++)
{
_windows *pWindows = &Windows[i];

if(pWindows->Active)
//if(!pWindows->Reduit)
if((pWindows->Position.x<x)&&
   ((pWindows->Position.x+pWindows->Taille.x)>x)&&
   ((pWindows->Position.y)<y)&&
   ((pWindows->Position.y+pWindows->Taille.y)>y))
{
if(pWindows->Place<LastPos)
{
LastPos=pWindows->Place;
LastWin = i;
}
}

}
return LastWin;
}

int _HUD::ClickBorder(int x,int y)
{
int LastWin=-1;
int LastPos=1000; 
for(int i=0;i<NDWindows;i++)
{
_windows *pWindows = &Windows[i];
if(pWindows->Active)
if((pWindows->Position.x<x)&&
   ((pWindows->Position.x+pWindows->Taille.x)>x)&&
   ((pWindows->Position.y+pWindows->Taille.y-BorderSize)<y)&&
   ((pWindows->Position.y+pWindows->Taille.y)>y))
{
if(pWindows->Place<LastPos)
{
LastPos=pWindows->Place;
LastWin = i;
}

}
}
return LastWin;
}

int _HUD::ClickRed(int x,int y)
{
int LastWin=-1;
int LastPos=1000; 
for(int i=0;i<NDWindows;i++)
{
_windows *pWindows = &Windows[i];
if(pWindows->Active)
if(pWindows->bRed)
if(((pWindows->Position.x+pWindows->Taille.x-BorderSize*2)<x)&&
   ((pWindows->Position.x+pWindows->Taille.x-BorderSize)>x)&&
   ((pWindows->Position.y+pWindows->Taille.y-BorderSize)<y)&&
   ((pWindows->Position.y+pWindows->Taille.y)>y))
{
if(pWindows->Place<LastPos)
{
LastPos=pWindows->Place;
LastWin = i;
}
}
}
return LastWin;
}

int _HUD::ClickClose(int x,int y)
{
int LastWin=-1;
int LastPos=1000; 
for(int i=0;i<NDWindows;i++)
{
_windows *pWindows = &Windows[i];
if(pWindows->Active)
if(pWindows->bQuit)
if(((pWindows->Position.x+pWindows->Taille.x-BorderSize)<x)&&
   ((pWindows->Position.x+pWindows->Taille.x)>x)&&
   ((pWindows->Position.y+pWindows->Taille.y-BorderSize)<y)&&
   ((pWindows->Position.y+pWindows->Taille.y)>y))
{
if(pWindows->Place<LastPos)
{
LastPos=pWindows->Place;
LastWin = i;
}
}
}
return LastWin;
}

int _HUD::ObjetInWindows(int win,int x,int y)
{

	_windows *pWindows = &Windows[win];

for(int i=0;i<pWindows->NDObjet;i++)
if(pWindows->Objet[i].Active)
{
_Objet* pObjet = &pWindows->Objet[i];
if(((pObjet->Position.x+pWindows->Position.x)<x)&&
   ((pObjet->Position.x+pObjet->Taille.x+pWindows->Position.x)>x)&&
   ((pObjet->Position.y+pWindows->Position.y)<y)&&
   ((pObjet->Position.y+pObjet->Taille.y+pWindows->Position.y)>y))
   return i;

}
return -1;
}

void _HUD::DesactiveAllFocus()
{
for(int i=0;i<NDWindows;i++)
{
_windows *pWindows = &Windows[i];
if(pWindows->Active)
{
for(int j=0;j<Windows[i].NDObjet;j++)
if(Windows[i].Objet[j].Active)
{
Windows[i].Objet[j].Focus = false;
}
}
}
UseObjetFocus = false;
}

void _HUD::MouseClick(int button,int state,int x,int y)
{

y -= WindowsY;
y*=-1;
WinMove = -1;


static int LastState;
if(state==GLUT_DOWN)
{
Mouse = button;
MousePos.x = x;
MousePos.y = y;
if(LastState!=GLUT_DOWN)
MousePosFC = MousePos;
}
else
Mouse = MOUSE_NOP;	
LastState=state;

	if((state==GLUT_DOWN)||(button==MOUSE_LEFT))
	{

		DesactiveAllFocus();

	int tmpW = ClickWindows(x,y);
	SetFocusWindows(tmpW);

	int tmpW2= ClickBorder(x,y);
	SetFocusWindows(tmpW);

	int tmpW3= ClickClose(x,y);

	int tmpW4= ClickRed(x,y);


	if(tmpW3!=-1)
	{
	Windows[tmpW].Active = false;
	//Windows[tmpW].Reduit =  !Windows[tmpW].Reduit ;
	}

	if(tmpW4!=-1)
	{
	Windows[tmpW].Reduit =  !Windows[tmpW].Reduit ;
	}

	if((tmpW2!=-1)&&((tmpW4==-1)&&(tmpW3==-1)))
	{
	WinMove=tmpW;
	MousePosFC.x = x - Windows[WinMove].Position.x;
	MousePosFC.y = y - Windows[WinMove].Position.y;
	}

	if((tmpW!=-1)&&(tmpW2==-1))
	{
		int ObjetClick = ObjetInWindows(tmpW,x,y);
		if(ObjetClick!=-1)
			{
			pObjetDeclick = &Windows[tmpW].Objet[ObjetClick];
			UseObjetDeclick = true;

			pObjetFocus =  &Windows[tmpW].Objet[ObjetClick];
			UseObjetFocus = true,
			pObjetFocus->Focus = true;

			Windows[tmpW].Objet[ObjetClick].ClicOn = true;
			//printf("Click on %s\n",Windows[tmpW].Objet[ObjetClick].Name);

			if(pObjetDeclick->Type==TYPE_BUTTON)
			if(pObjetDeclick->UseOnClick)
				pObjetDeclick->OnClick();
			}

	}

	}
else
	{
	WinMove = -1;
	if(UseObjetDeclick)
	pObjetDeclick->ClicOn = false;
	UseObjetDeclick = false;
	}



}

bool IsGooChar(unsigned char key)
{
	if((key>=48)&&(key<=126)) return true;
	return false;
}

void SendKey(_Objet *pObjet,unsigned char key)
{

if(IsGooChar(key))
{
char tAdd[2];
tAdd[0] = key;
tAdd[1] = '\0';
strcat(pObjet->Caption,tAdd);
}

if (key=='\10')
{
pObjet->Caption[strlen(pObjet->Caption)-1] = '\0';
}

if (key=='\r')
{
if(pObjet->UseOnClick)
	pObjet->OnClick();
}

}

void _HUD::Key(unsigned char key)
{


	if(UseObjetFocus)
	if((pObjetFocus->Active)&&
		(pObjetFocus->Focus))
	{

	if(pObjetFocus->Type==TYPE_TEXT)
		{
		SendKey(pObjetFocus,key);
		}
	}


	/*
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
{
for(int j=0;j<Windows[i].NDObjet;j++)
if(Windows[i].Objet[j].Active)
if(Windows[i].Objet[j].ClicOn)
{
_Objet* pObjet = &Windows[i].Objet[j];
if(pObjet->Type==TYPE_TEXT)
{

	strcpy(pObjet->Caption,"aze");

}
}
}*/
}

void Ecrire(int x,int y,char *texte)
{
	unsigned int i;
	glRasterPos2d(x,y);
	for (i = 0; i < strlen (texte); i++)
		glutBitmapCharacter (GLUT_BITMAP_HELVETICA_12, texte[i]);
		//glutBitmapCharacter (GLUT_BITMAP_HELVETICA_10, texte[i]);
}

void DrawWindows(_windows *pWindows,int Texture)
{

if(pWindows->Blend<1)
{
glEnable(GL_BLEND);
glBlendFunc(GL_SRC_COLOR,GL_ONE_MINUS_SRC_COLOR);
//glColor4f(0.0f,0.0f,0.0f,pWindows->Blend);
glColor4f(0.0f,0.0f,0.0f,pWindows->Blend);
}

glBegin(GL_QUADS);

if(!pWindows->Reduit)
{
int decal = 3;
glColor3f(0.4f,0.4f,0.4f);		
glVertex2d(pWindows->Position.x-1+decal,pWindows->Position.y-1-decal);
glVertex2d(pWindows->Position.x+pWindows->Taille.x+1+decal,pWindows->Position.y-1-decal);
glVertex2d(pWindows->Position.x+pWindows->Taille.x+1+decal,pWindows->Position.y+pWindows->Taille.y+1-decal);
glVertex2d(pWindows->Position.x-1+decal,pWindows->Position.y+pWindows->Taille.y+1-decal);		



glColor3f(0.0f,0.0f,0.0f);		
glVertex2d(pWindows->Position.x-1,pWindows->Position.y-1);
glVertex2d(pWindows->Position.x+pWindows->Taille.x+1,pWindows->Position.y-1);
glVertex2d(pWindows->Position.x+pWindows->Taille.x+1,pWindows->Position.y+pWindows->Taille.y+1);
glVertex2d(pWindows->Position.x-1,pWindows->Position.y+pWindows->Taille.y+1);		
}


if(pWindows->Place==1)
{
glColor3f(0.2f,0.2f,0.7f);
glVertex2d(pWindows->Position.x,					pWindows->Position.y+pWindows->Taille.y-BorderSize);
glVertex2d(pWindows->Position.x,					pWindows->Position.y+pWindows->Taille.y);
glColor3f(0.4f,0.4f,0.9f);
glVertex2d(pWindows->Position.x+pWindows->Taille.x,	pWindows->Position.y+pWindows->Taille.y);
glVertex2d(pWindows->Position.x+pWindows->Taille.x,	pWindows->Position.y+pWindows->Taille.y-BorderSize);
glEnd();
}
else
{
glColor3f(0.2f,0.2f,0.6f);
glVertex2d(pWindows->Position.x,					pWindows->Position.y+pWindows->Taille.y-BorderSize);
glVertex2d(pWindows->Position.x,					pWindows->Position.y+pWindows->Taille.y);
glColor3f(0.4f,0.4f,0.8f);
glVertex2d(pWindows->Position.x+pWindows->Taille.x,	pWindows->Position.y+pWindows->Taille.y);
glVertex2d(pWindows->Position.x+pWindows->Taille.x,	pWindows->Position.y+pWindows->Taille.y-BorderSize);
glEnd();
}


if(pWindows->bQuit)
{
glColor3f(0.2f,0.2f,0.6f);
glBindTexture(GL_TEXTURE_2D,Texture);
glEnable(GL_TEXTURE_2D);
glBindTexture(GL_TEXTURE_2D,Texture);
glEnable(GL_TEXTURE_2D);
glBegin(GL_QUADS);		
glTexCoord2f(0.0f, 0.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x-BorderSize	, pWindows->Position.y+pWindows->Taille.y-BorderSize );
glTexCoord2f(0.0f, 1.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x-BorderSize	,pWindows->Position.y+pWindows->Taille.y);
glTexCoord2f(.18f, 1.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x			,pWindows->Position.y+pWindows->Taille.y);
glTexCoord2f(.18f, 0.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x			,pWindows->Position.y+pWindows->Taille.y-BorderSize  );
glEnd();
glDisable(GL_TEXTURE_2D);
}

if(pWindows->bRed)
{
glColor3f(0.2f,0.2f,0.6f);
glBindTexture(GL_TEXTURE_2D,Texture);
glEnable(GL_TEXTURE_2D);
glBindTexture(GL_TEXTURE_2D,Texture);
glEnable(GL_TEXTURE_2D);
glBegin(GL_QUADS);		
glTexCoord2f(0.0f+.18f, 0.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x-BorderSize*2	, pWindows->Position.y+pWindows->Taille.y-BorderSize );
glTexCoord2f(0.0f+.18f, 1.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x-BorderSize*2	,pWindows->Position.y+pWindows->Taille.y);
glTexCoord2f(.18f*2, 1.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x-BorderSize			,pWindows->Position.y+pWindows->Taille.y);
glTexCoord2f(.18f*2, 0.0f); glVertex2d(pWindows->Position.x+pWindows->Taille.x-BorderSize			,pWindows->Position.y+pWindows->Taille.y-BorderSize  );
glEnd();
glDisable(GL_TEXTURE_2D);
}

if(!pWindows->Reduit)
{
glBegin(GL_QUADS);
glColor3f(0.8f,0.8f,0.8f);		
glVertex2d(pWindows->Position.x,pWindows->Position.y);
glVertex2d(pWindows->Position.x+pWindows->Taille.x,pWindows->Position.y);
glVertex2d(pWindows->Position.x+pWindows->Taille.x,pWindows->Position.y+pWindows->Taille.y-BorderSize);
glVertex2d(pWindows->Position.x,pWindows->Position.y+pWindows->Taille.y-BorderSize);
glEnd();
}

glColor3f(0.0f,0.0f,0.0f);
Ecrire(pWindows->Position.x + 19 ,pWindows->Position.y+pWindows->Taille.y -BorderSize*0.5 -4,pWindows->Caption);

glColor3f(0.8f,0.8f,0.8f);
Ecrire(pWindows->Position.x + 20 ,pWindows->Position.y+pWindows->Taille.y -BorderSize*0.5 -3,pWindows->Caption);

if(pWindows->Blend<1)
{
glDisable(GL_BLEND);
}

}

void _HUD::Inis(char *BMP,bool Fond)
{
NDWindows = 0;
WindowsX = 0;
WindowsY = 0;
WinMove = 0;
Font = Fond;
CreateTexture(TextureA,BMP,1);
}

void _HUD::Draw()
{

glLoadIdentity();

if(Font)
{
	glBegin(GL_QUADS);
	glColor3f(0.5f,0.5f,0.7f);
	glVertex2d(0,0);
	glVertex2d(WindowsX,0);
	glColor3f(0.7f,0.7f,0.9f);
	glVertex2d(WindowsX,WindowsY);
	glVertex2d(0,WindowsY);	
	glEnd();
}

for(int TmpPlace=NDWindows;TmpPlace>=1;TmpPlace--)
{
for(int i=0;i<NDWindows;i++)
{
if((Windows[i].Place==TmpPlace)&&(Windows[i].Active))
{

glLoadIdentity();
DrawWindows(&Windows[i],TextureA[1]);
if(!Windows[i].Reduit)
Windows[i].DrawObjet();
}
}
}

}

void _HUD::AddWindows(char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,bool CloseB,bool RedB,float Blend)
{

_windows TmpWin;
strcpy(&TmpWin.Caption[0],Caption);
strcpy(&TmpWin.Name[0],Name);
TmpWin.Active = true;
TmpWin.Position = Pos;
TmpWin.Taille = Tail;
TmpWin.Place = 0;
TmpWin.bQuit = CloseB;
TmpWin.bRed = RedB;
TmpWin.Blend =Blend;
TmpWin.Reduit = false;

TmpWin.NDObjet = 0;

Windows.push_back(TmpWin);
NDWindows++;

SetFocusWindows(NDWindows-1);

}

void _HUD::SetObjetCaption(char* Win,char* Objet,char* Caption)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
for(int j=0;j<Windows[i].NDObjet;j++)
if(Windows[i].Objet[j].Active)
if(!strcmp(Objet,Windows[i].Objet[j].Name))
{
strcpy(Windows[i].Objet[j].Caption,Caption);
}
}
}

void _HUD::GetObjetCaption(char* Win,char* Objet,char* Caption)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
for(int j=0;j<Windows[i].NDObjet;j++)
if(Windows[i].Objet[j].Active)
if(!strcmp(Objet,Windows[i].Objet[j].Name))
{
strcpy(Caption,Windows[i].Objet[j].Caption);
}
}
}

void _HUD::SetWindowsCaption(char* Win,char* Caption)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
strcpy(Windows[i].Caption,Caption);
}
}

void _HUD::KillWindow(char* Win)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
Windows[i].Active = false;
}
}

void _HUD::ReduceWindow(char* Win)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
Windows[i].Reduit = true;
}
}
void _HUD::ExpendWindow(char* Win)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
Windows[i].Reduit = false;
}
}
void _HUD::SetWindowPos(char* Win,int x, int y)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
Windows[i].Position.x = x;
Windows[i].Position.y = y;
}
}
void _HUD::SetWindowBlend(char* Win,float Blend)
{
for(int i=0;i<NDWindows;i++)
if(Windows[i].Active)
if(!strcmp(Win,Windows[i].Name))
{
Windows[i].Blend = Blend;
}
}

void _HUD::AddObjetToWindows(char *wName,char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,int type,void(*OnClick)())
{
for(int i=0;i<NDWindows;i++)
{
if(!strcmp(wName,Windows[i].Name))
{
Windows[i].AddObjet(Caption,Name,Pos,Tail,type,OnClick);
}
}
}

void DrawLabel(char *Caption,_iPoint2D Pos,_iPoint2D Tail)
{
glColor3f(0.0f,0.0f,0.0f);
Ecrire(Pos.x+5 ,Pos.y+5,Caption);
}

void DrawText(char *Caption,_iPoint2D Pos,_iPoint2D Tail,bool select)
{
glBegin(GL_QUADS);
glColor3f(0.0f,0.0f,0.0f);
glVertex2d(Pos.x-1,Pos.y-1);
glVertex2d(Pos.x+Tail.x+1,Pos.y-1);
glVertex2d(Pos.x+Tail.x+1,Pos.y+Tail.y+1);
glVertex2d(Pos.x-1,Pos.y+Tail.y+1);

if(select)
glColor3f(1.f,1.f,1.f);
else
glColor3f(0.9f,0.9f,0.9f);

glVertex2d(Pos.x,Pos.y);
glVertex2d(Pos.x+Tail.x,Pos.y);
glVertex2d(Pos.x+Tail.x,Pos.y+Tail.y);
glVertex2d(Pos.x,Pos.y+Tail.y);

glEnd();
glColor3f(0.0f,0.0f,0.0f);
Ecrire(Pos.x+5 ,Pos.y+5,Caption);
}

void DrawButton(char *Caption,_iPoint2D Pos,_iPoint2D Tail,bool Clic)
{

glBegin(GL_QUADS);
glColor3f(0.0f,0.0f,0.0f);
glVertex2d(Pos.x-1,Pos.y-2);
glVertex2d(Pos.x+Tail.x+2,Pos.y-2);
glVertex2d(Pos.x+Tail.x+2,Pos.y+Tail.y+1);
glVertex2d(Pos.x-1,Pos.y+Tail.y+1);

if(Clic)
glColor3f(0.5f,0.5f,0.5f);
else
glColor3f(0.8f,0.8f,0.8f);

glVertex2d(Pos.x,Pos.y);
glVertex2d(Pos.x+Tail.x,Pos.y);
glVertex2d(Pos.x+Tail.x,Pos.y+Tail.y);
glVertex2d(Pos.x,Pos.y+Tail.y);


glEnd();

glColor3f(0.0f,0.0f,0.0f);
Ecrire(Pos.x+5 ,Pos.y+5,Caption);
}

void _windows::DrawObjet()
{
glTranslated(Position.x,Position.y,0);
for(int i=0;i<NDObjet;i++)
{
_Objet *pObjet = &Objet[i];
switch(pObjet->Type)
{
case TYPE_LABEL:
	DrawLabel(pObjet->Caption,pObjet->Position,pObjet->Taille);
	break;
case TYPE_BUTTON:
	DrawButton(pObjet->Caption,pObjet->Position,pObjet->Taille,pObjet->ClicOn);
	break;
case TYPE_TEXT:
	DrawText(pObjet->Caption,pObjet->Position,pObjet->Taille,pObjet->Focus);
	break;
}
}
}

void _windows::AddObjet(char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,int type,void(*OnClick)())
{
_Objet TmpObjet;

strcpy(&TmpObjet.Caption[0],Caption);
strcpy(&TmpObjet.Name[0],Name);
TmpObjet.Position = Pos;
TmpObjet.Taille = Tail;
TmpObjet.Type = type;
TmpObjet.Active = true;
TmpObjet.ClicOn = false;
TmpObjet.OnClick = OnClick;
TmpObjet.Focus = false;

if(OnClick!=NULL) 
TmpObjet.UseOnClick = true;
else
TmpObjet.UseOnClick = false;
 
Objet.push_back(TmpObjet);
NDObjet++;
}